function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

import { __extends } from 'tslib';
import { isValidElement, Fragment, cloneElement, Children, Component } from 'react';
import { generateUID, stringifyCSSRules } from './utils.js';

var MUT_STYLE_CLASS = 'data-mut-style-class';
function createStyleToDocument(styleContent) {
    var head = document.head;
    var style = document.createElement('style');
    var css = document.createTextNode(styleContent);
    style.setAttribute('type', 'text/css');
    head.appendChild(style);
    style.appendChild(css);
    return {
        updateCSS: function (rules) {
            css.nodeValue = rules;
        },
    };
}
// interface IMutStyleState {}
var MutStyle = /** @class */ (function (_super) {
    __extends(MutStyle, _super);
    function MutStyle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.uid = generateUID();
        _this.scopePrefix = "[" + MUT_STYLE_CLASS + "=\"" + _this.uid + "\"]";
        _this.mutStyle = createStyleToDocument(stringifyCSSRules(_this.props.css, _this.scopePrefix));
        _this.childrenRefs = [];
        _this.setScopeAttrToChildren = function () {
            _this.childrenRefs.forEach(function (childRef) {
                if (childRef instanceof Element) {
                    childRef.setAttribute(MUT_STYLE_CLASS, _this.uid);
                }
            });
        };
        _this.setChildRef = function (ref, index) {
            _this.childrenRefs[index] = ref;
        };
        _this.assignChildRef = function (child, index) {
            if (index === void 0) { index = 0; }
            if (isValidElement(child)) {
                if (child.type === Fragment) {
                    return cloneElement(child, {}, 
                    // @ts-ignore Child props never be undefined
                    Children.map(child.props.children, _this.assignChildRef));
                }
                return cloneElement(child, {
                    // @ts-ignore
                    ref: function (ref) {
                        _this.setChildRef(ref, index);
                        // @ts-ignore Keep the origin ref
                        if (typeof child.ref === 'function') {
                            // @ts-ignore
                            child.ref(ref);
                        }
                    },
                });
            }
            else {
                return child;
            }
        };
        return _this;
    }
    MutStyle.prototype.componentDidMount = function () {
        this.setScopeAttrToChildren();
    };
    MutStyle.prototype.componentDidUpdate = function () {
        this.mutStyle.updateCSS(stringifyCSSRules(this.props.css, this.scopePrefix));
        this.setScopeAttrToChildren();
    };
    MutStyle.prototype.render = function () {
        var children = this.props.children;
        if (Array.isArray(children)) {
            return Children.map(children, this.assignChildRef);
        }
        return this.assignChildRef(children);
    };
    return MutStyle;
}(Component));

export default MutStyle;
